
;Dialog Window With Subclassed Static Control - DednDave, 4-2012

        .XCREF
        .NOLIST
        INCLUDE    \masm32\include\masm32rt.inc
        .LIST
        INCLUDE    DlgSubStatic.inc

;###############################################################################################

        .DATA

;***********************************************************************************************

        .DATA?
        ALIGN   4

hInstance   dd ?
hDlg        dd ?
hIcon       dd ?
hStatic     dd ?
lpfnStc     dd ?

;###############################################################################################

        .CODE

;***********************************************************************************************

DlgProc PROC    hWndDlg:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

        mov     eax,uMsg

        .if eax==WM_INITDIALOG

            ;intialize the global dialog window handle

            push    ebx
            mov     ebx,hWndDlg
            mov     hDlg,ebx

            ;load the icon from resource and set to caption bar

            INVOKE  LoadIcon,hInstance,IDI_ICON
            mov     hIcon,eax
            INVOKE  SendMessage,ebx,WM_SETICON,ICON_BIG,eax

            ;get and save the handle for the static control

            INVOKE  GetDlgItem,ebx,IDC_STATIC
            mov     hStatic,eax
            mov     ebx,eax

            ;get and save the original WndProc for the edit control

            INVOKE  GetWindowLong,ebx,GWL_WNDPROC
            mov     lpfnStc,eax

            ;subclass the edit control

            INVOKE  SetWindowLong,ebx,GWL_WNDPROC,StcProc
            pop     ebx

        .elseif eax==WM_CLOSE

            ;restore the original WndProc

            INVOKE  SetWindowLong,hStatic,GWL_WNDPROC,lpfnStc

            ;destroy the dialog window

            INVOKE  EndDialog,hWndDlg,NULL

        .else

            ;return FALSE

            xor     eax,eax
            jmp     DlgPrZ

        .endif

        ;return TRUE

        mov     eax,TRUE

;return EAX

DlgPrZ: ret

DlgProc ENDP

;***********************************************************************************************

StcProc PROC  hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

;  For messages that are received by StcProc that we want the system to handle, we exit
;by a call to the original WndProc via CallWindowProc. This is followed by a RET that
;passes the EAX value from the system WndProc.
;  For messages that we want to handle, and not allow the original WndProc to handle, we
;typically return FALSE (0) in EAX. This may vary for different messages. Refer to the
;documentation for each message type.
;  In rare cases, we may want to handle a message after the system WndProc has handled it.
;We can call the original WndProc via CallWindowProc, then insert our code afterward.

;return via original (system) WndProc

StcPrY: INVOKE  CallWindowProc,lpfnStc,hWnd,uMsg,wParam,lParam

;return EAX

StcPrZ: ret

StcProc ENDP

;***********************************************************************************************

_main   PROC

;------------------------------

;initialize common controls

        xor     edi,edi                                 ;EDI = 0
        push    edi
        push    sizeof INITCOMMONCONTROLSEX
        INVOKE  InitCommonControlsEx,esp
        pop     ecx
        pop     edx

;------------------------------

;create dialog box

        INVOKE  GetModuleHandle,edi
        mov     hInstance,eax
        INVOKE  DialogBoxParam,eax,IDW_DLG,edi,DlgProc,edi

;------------------------------

;exit program

        INVOKE  ExitProcess,eax

;------------------------------

_main   ENDP

;###############################################################################################

        END     _main

